// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function PingInitialize(client, state){
  return true;
}
function PingFreeState(state){
  delete(state);
}
function PingIteration(client, state){
  var request;
  var resString, reqString;
  var response;

  request = {};

  ServerReceive(client, request);

  reqString = UTF8ToUTF16(request.bytes);

  if(StringsEqual(reqString, "ping".split(''))){
    resString = "pong".split('');
  }else{
    resString = "error".split('');
  }

  response = UTF16ToUTF8(resString);

  ServerSend(client, response);

  delete(request);
  delete(response);
}
function test(){
  var failures;

  failures = CreateNumberReference(0);

  TestPing1(failures);

  return failures.numberValue;
}
function TestPing1(failures){
  var client;
  var str;
  var state;
  var success;

  client = {};
  client.requests = [];
  client.requests.length = 2;
  client.requests[0] = {};
  client.requests[0].numberArray = StringToNumberArray("ping".split(''));
  client.requests[1] = {};
  client.requests[1].numberArray = StringToNumberArray("test".split(''));
  client.requestCount = 0;
  client.responseCount = 0;
  client.responses = [];
  client.responses.length = 2;
  client.check = [];
  client.check.length = 2;
  client.check[0] = 0;
  client.check[1] = 100;

  state = {};
  success = PingInitialize(client, state);
  AssertTrue(success, failures);

  PingIteration(client, state);
  PingIteration(client, state);

  AssertEquals(client.responseCount, 2, failures);

  str = NumberArrayToString(client.responses[0].numberArray);
  AssertStringEquals(str, "pong".split(''), failures);

  str = NumberArrayToString(client.responses[1].numberArray);
  AssertStringEquals(str, "error".split(''), failures);

  PingFreeState(state);
}
function Check(pu){
  var avaialble;
  var count;

  if(pu.responseCount < pu.check.length){
    count = pu.check[pu.responseCount];

    if(count <= 0){
      avaialble = true;
    }else{
      avaialble = false;
      count = count - 1;
    }

    pu.check[pu.responseCount] = count;
  }else{
    avaialble = true;
  }

  return avaialble;
}
function Send(pu, data){
  pu.requests[pu.requestCount] = {};
  pu.requests[pu.requestCount].numberArray = data.bytes;
  pu.requestCount = pu.requestCount + 1;
}
function Receive(pu, data){
  data.bytes = {};
  data.bytes.bytes = pu.responses[pu.responseCount].numberArray;
  pu.responseCount = pu.responseCount + 1;
}
function Call(pu, request, response){
  Send(pu, request);
  Receive(pu, response);
}
function ServerCheck(pu){
  var avaialble;
  var count;

  if(pu.requestCount < pu.check.length){
    count = pu.check[pu.requestCount];

    if(count <= 0){
      avaialble = true;
    }else{
      avaialble = false;
      count = count - 1;
    }

    pu.check[pu.requestCount] = count;
  }else{
    avaialble = true;
  }

  return avaialble;
}
function ServerSend(pu, data){
  pu.responses[pu.responseCount] = {};
  pu.responses[pu.responseCount].numberArray = data.bytes;
  pu.responseCount = pu.responseCount + 1;
}
function ServerReceive(pu, data){
  data.bytes = {};
  data.bytes.bytes = pu.requests[pu.requestCount].numberArray;
  pu.requestCount = pu.requestCount + 1;
}
function StringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function NumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function NumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function BooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function StringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function FillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function IsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function CreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillNumberArray(array, value);

  return array;
}
function CreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillBooleanArray(array, value);

  return array;
}
function CreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillString(array, value);

  return array;
}
function SwapElementsOfNumberArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}
function SwapElementsOfStringArray(A, ai, bi){
  var tmp;

  tmp = A.stringArray[ai];
  A.stringArray[ai] = A.stringArray[bi];
  A.stringArray[bi] = tmp;
}
function ReverseNumberArray(array){
  var i;

  for(i = 0; i < array.length/2; i = i + 1){
    SwapElementsOfNumberArray(array, i, array.length - i - 1);
  }
}
function ReadXbytes(data, position, lengthx){
  var r;
  var i;

  r = CreateByteArray(lengthx);

  for(i = 0; i < lengthx; i = i + 1){
    r.bytes[i] = ReadByte(data, position);
  }

  return r;
}
function Read4bytesBE(data, position){
  var r;

  r = 0;
  r = r + Math.pow(2, 24)*ReadByte(data, position);
  r = r + Math.pow(2, 16)*ReadByte(data, position);
  r = r + Math.pow(2, 8)*ReadByte(data, position);
  r = r + ReadByte(data, position);

  return r;
}
function Read2bytesBE(data, position){
  var r;

  r = 0;
  r = r + Math.pow(2, 8)*ReadByte(data, position);
  r = r + ReadByte(data, position);

  return r;
}
function ReadByte(data, position){
  var next;

  next = data.bytes[position.numberValue];
  position.numberValue = position.numberValue + 1;

  return next;
}
function Read4bytesLE(data, position){
  var r;

  r = 0;
  r = r + ReadByte(data, position);
  r = r + Math.pow(2, 8)*ReadByte(data, position);
  r = r + Math.pow(2, 16)*ReadByte(data, position);
  r = r + Math.pow(2, 24)*ReadByte(data, position);

  return r;
}
function WriteByte(data, b, position){
  data.bytes[position.numberValue] = b;
  position.numberValue = position.numberValue + 1;
}
function Write2BytesLE(data, b, position){
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
}
function Write4BytesLE(data, b, position){
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 16))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 24))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
}
function Write2BytesBE(data, b, position){
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
}
function Write4BytesBE(data, b, position){
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 24))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 16))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
}
function WriteStringBytes(data, cs, position){
  var i, v;

  for(i = 0; i < cs.length; i = i + 1){
    v = cs[i].charCodeAt(0);
    WriteByte(data, v, position);
  }
}
function BytesRound(x){
  return Math.floor(x + 0.5);
}
function ByteArrayToNumberArray(src){
  var dst;
  var i, len;

  len = src.bytes.length;
  dst = [];
  dst.length = len;
  for(i = 0; i < len; i = i + 1){
    dst[i] = src.bytes[i];
  }

  return dst;
}
function NumberArrayToByteArray(src){
  var dst;
  var i, len;

  len = src.length;
  dst = {};
  dst.bytes = [];
  dst.bytes.length = len;
  for(i = 0; i < len; i = i + 1){
    dst.bytes[i] = src[i];
  }

  return dst;
}
function ByteArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.bytes.length == b.bytes.length){
    for(i = 0; i < a.bytes.length && equal; i = i + 1){
      if(a.bytes[i] != b.bytes[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function CopyByteArray(a){
  var i;
  var n;

  n = {};
  n.bytes = [];
  n.bytes.length = a.bytes.length;

  for(i = 0; i < a.bytes.length; i = i + 1){
    n.bytes[i] = a.bytes[i];
  }

  return n;
}
function ByteArrayLength(response){
  return response.bytes.length;
}
function CreateAndFillByteArray(lengthx, value){
  var bytes;
  var i;

  bytes = {};
  bytes.bytes = [];
  bytes.bytes.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    bytes.bytes[i] = value;
  }

  return bytes;
}
function CreateByteArray(lengthx){
  var bytes;

  bytes = {};
  bytes.bytes = [];
  bytes.bytes.length = lengthx;

  return bytes;
}
function SetByte(array, index, value){
  array.bytes[index] = value;
}
function GetByte(array, index){
  return array.bytes[index];
}
function AssertByteArraysEqual(a, b, failures){
  var i;

  if(a.bytes.length == b.bytes.length){
    for(i = 0; i < a.bytes.length; i = i + 1){
      if(GetByte(a, i) != GetByte(b, i)){
        failures.numberValue = failures.numberValue + 1;
      }
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function FreeByteArray(byteArray){
  delete(byteArray.bytes);
  delete(byteArray);
}
function CopyByteArrayRange(a, from, to, b){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.bytes.length && to >= 0 && to <= a.bytes.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a.bytes[from + i];
    }

    b.bytes = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function BytesToTextBase16(bytes){
  var comb;
  var i, v;
  var r;

  r = [];
  r.length = bytes.bytes.length*2;
  comb = GenerateBase16ByteCombinations();

  for(i = 0; i < bytes.bytes.length; i = i + 1){
    v = bytes.bytes[i];
    r[2*i + 0] = comb[v].string[0];
    r[2*i + 1] = comb[v].string[1];
  }

  FreeBase64ByteCombinations(comb);

  return r;
}
function TextToBytesBase16WithCheck(string, bytes, message){
  var comb;
  var i, n, c, d;
  var reverseBase16;
  var codes;
  var success;

  codes = "0123456789ABCDEF".split('');

  reverseBase16 = [];
  reverseBase16.length = 128;
  for(i = 0; i < codes.length; i = i + 1){
    n = codes[i].charCodeAt(0);
    reverseBase16[n] = i;
  }

  if(string.length%2 == 0){
    bytes.bytes = CreateByteArray(string.length/2);
    comb = GenerateBase16ByteCombinations();

    success = true;
    for(i = 0; i < string.length/2 && success; i = i + 1){
      c = string[2*i + 0].charCodeAt(0);
      d = string[2*i + 1].charCodeAt(0);

      if(c == 'a'.charCodeAt(0)){
        c = 'A'.charCodeAt(0);
      }
      if(c == 'b'.charCodeAt(0)){
        c = 'B'.charCodeAt(0);
      }
      if(c == 'c'.charCodeAt(0)){
        c = 'C'.charCodeAt(0);
      }
      if(c == 'd'.charCodeAt(0)){
        c = 'D'.charCodeAt(0);
      }
      if(c == 'e'.charCodeAt(0)){
        c = 'E'.charCodeAt(0);
      }
      if(c == 'f'.charCodeAt(0)){
        c = 'F'.charCodeAt(0);
      }

      if(d == 'a'.charCodeAt(0)){
        d = 'A'.charCodeAt(0);
      }
      if(d == 'b'.charCodeAt(0)){
        d = 'B'.charCodeAt(0);
      }
      if(d == 'c'.charCodeAt(0)){
        d = 'C'.charCodeAt(0);
      }
      if(d == 'd'.charCodeAt(0)){
        d = 'D'.charCodeAt(0);
      }
      if(d == 'e'.charCodeAt(0)){
        d = 'E'.charCodeAt(0);
      }
      if(d == 'f'.charCodeAt(0)){
        d = 'F'.charCodeAt(0);
      }

      success = true;
      success = success && (c == '0'.charCodeAt(0) || c == '1'.charCodeAt(0) || c == '2'.charCodeAt(0) || c == '3'.charCodeAt(0) || c == '4'.charCodeAt(0) || c == '5'.charCodeAt(0) || c == '6'.charCodeAt(0) || c == '7'.charCodeAt(0) || c == '8'.charCodeAt(0) || c == '9'.charCodeAt(0) || c == 'A'.charCodeAt(0) || c == 'B'.charCodeAt(0) || c == 'C'.charCodeAt(0) || c == 'D'.charCodeAt(0) || c == 'E'.charCodeAt(0) || c == 'F'.charCodeAt(0));
      success = success && (d == '0'.charCodeAt(0) || d == '1'.charCodeAt(0) || d == '2'.charCodeAt(0) || d == '3'.charCodeAt(0) || d == '4'.charCodeAt(0) || d == '5'.charCodeAt(0) || d == '6'.charCodeAt(0) || d == '7'.charCodeAt(0) || d == '8'.charCodeAt(0) || d == '9'.charCodeAt(0) || d == 'A'.charCodeAt(0) || d == 'B'.charCodeAt(0) || d == 'C'.charCodeAt(0) || d == 'D'.charCodeAt(0) || d == 'E'.charCodeAt(0) || d == 'F'.charCodeAt(0));

      if(success){
        n = reverseBase16[c]*16 + reverseBase16[d];

        bytes.bytes.bytes[i] = n;
      }else{
        success = false;
        message.string = "Hex-string can only contain 0-9, A-F or a-f.".split('');
      }
    }

    FreeBase64ByteCombinations(comb);
  }else{
    bytes.bytes = CreateByteArray(0);
    success = false;
    message.string = "Hex-string must be an even number of characters.".split('');
  }

  delete(reverseBase16);

  return success;
}
function TextToBytesBase16(string){
  var comb;
  var i, n, c, d;
  var r;
  var reverseBase16;
  var codes;

  codes = "0123456789ABCDEF".split('');

  reverseBase16 = [];
  reverseBase16.length = 128;
  for(i = 0; i < codes.length; i = i + 1){
    n = codes[i].charCodeAt(0);
    reverseBase16[n] = i;
  }

  if(string.length%2 == 0){
    r = CreateByteArray(string.length/2);
    comb = GenerateBase16ByteCombinations();

    for(i = 0; i < string.length/2; i = i + 1){
      c = string[2*i + 0].charCodeAt(0);
      d = string[2*i + 1].charCodeAt(0);

      n = reverseBase16[c]*16 + reverseBase16[d];

      r.bytes[i] = n;
    }

    FreeBase64ByteCombinations(comb);
  }else{
    r = CreateByteArray(0);
  }

  delete(reverseBase16);

  return r;
}
function FreeBase64ByteCombinations(comb){
  var i;
  for(i = 0; i < 256; i = i + 1){
    FreeStringReference(comb[i]);
  }
  delete(comb);
}
function GenerateBase16ByteCombinations(){
  var comb;
  var codes;
  var i, j;
  comb = [];
  comb.length = 256;

  codes = "0123456789ABCDEF".split('');

  for(i = 0; i < 256; i = i + 1){
    comb[i] = {};
    comb[i].string = [];
    comb[i].string.length = 2;
  }

  for(j = 0; j < 16; j = j + 1){
    for(i = 0; i < 16; i = i + 1){
      comb[j*16 + i].string[1] = codes[i];
      comb[j*16 + i].string[0] = codes[j];
    }
  }

  return comb;
}
function UnicodeToUTF8(unicode){
  var utf8;
  var lengthx, i, pos, p1, p2, p3, p4, code;

  lengthx = 0;
  for(i = 0; i < unicode.length; i = i + 1){
    code = unicode[i];

    lengthx = lengthx + 1;
    if(code >= 128){
      lengthx = lengthx + 1;
    }
    if(code >= 2048){
      lengthx = lengthx + 1;
    }
    if(code >= 65536){
      lengthx = lengthx + 1;
    }
  }

  utf8 = CreateByteArray(lengthx);

  pos = 0;
  for(i = 0; i < unicode.length; i = i + 1){
    code = unicode[i];

    if(code < 128){
      SetByte(utf8, pos, code);
      pos = pos + 1;
    }else if(code < 2048){
      p1 = code%64;
      p2 = Math.floor(code/64)%64;

      SetByte(utf8, pos, 128 + 64 + p2);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p1);
      pos = pos + 1;
    }else if(code < 65536){
      p1 = code%64;
      p2 = Math.floor(code/64)%64;
      p3 = Math.floor(code/4096);

      SetByte(utf8, pos, 128 + 64 + 32 + p3);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p2);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p1);
      pos = pos + 1;
    }else{
      p1 = code%64;
      p2 = Math.floor(code/64)%64;
      p3 = Math.floor(code/4096)%64;
      p4 = Math.floor(code/262144);

      SetByte(utf8, pos, 128 + 64 + 32 + 16 + p4);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p3);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p2);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p1);
      pos = pos + 1;
    }
  }

  return utf8;
}
function UTF8ToUnicode(utf8){
  var utf;
  var lengthx, i, pos, p1, p2, p3, p4, code;

  lengthx = 0;
  for(i = 0; i < ByteArrayLength(utf8); ){
    code = Math.floor(GetByte(utf8, i)/8)*8;

    if(code < 128){
      lengthx = lengthx + 1;
      i = i + 1;
    }else if(code == 128 + 64){
      lengthx = lengthx + 1;
      i = i + 2;
    }else if(code == 128 + 64 + 32){
      lengthx = lengthx + 1;
      i = i + 3;
    }else if(code == 128 + 64 + 32 + 16){
      lengthx = lengthx + 1;
      i = i + 4;
    }
  }

  utf = [];
  utf.length = lengthx;

  pos = 0;
  for(i = 0; i < ByteArrayLength(utf8); ){
    code = Math.floor(GetByte(utf8, i)/8)*8;

    if(code < 128){
      utf[pos] = GetByte(utf8, i);
      i = i + 1;
      pos = pos + 1;
    }else if(code == 128 + 64){
      p1 = GetByte(utf8, i + 1) - 128;
      p2 = GetByte(utf8, i) - 128 - 64;

      utf[pos] = p2*64 + p1;

      i = i + 2;
      pos = pos + 1;
    }else if(code == 128 + 64 + 32){
      p1 = GetByte(utf8, i + 2) - 128;
      p2 = GetByte(utf8, i + 1) - 128;
      p3 = GetByte(utf8, i) - 128 - 64 - 32;

      utf[pos] = p3*4096 + p2*64 + p1;

      i = i + 3;
      pos = pos + 1;
    }else if(code == 128 + 64 + 32 + 16){
      p1 = GetByte(utf8, i + 3) - 128;
      p2 = GetByte(utf8, i + 2) - 128;
      p3 = GetByte(utf8, i + 1) - 128;
      p4 = GetByte(utf8, i) - 128 - 64 - 32 - 16;

      utf[pos] = p4*262144 + p3*4096 + p2*64 + p1;

      i = i + 4;
      pos = pos + 1;
    }
  }

  return utf;
}
function UTF16ToUnicode(utf16){
  var unicode;
  var lengthx, i, pos, hs, ls, code;
  var surrogateLowerBound, surrogateUpperBound, highSurrogateBase, lowSurrogateBase, highMultiplier, surrogateBase;

  surrogateLowerBound = 55296;
  surrogateUpperBound = 57344;
  highSurrogateBase = 55296;
  lowSurrogateBase = 56320;
  highMultiplier = 1024;
  surrogateBase = 65536;

  lengthx = 0;
  for(i = 0; i < utf16.length; ){
    code = utf16[i].charCodeAt(0);

    if(code < surrogateLowerBound || code >= surrogateUpperBound){
      lengthx = lengthx + 1;
      i = i + 1;
    }else{
      lengthx = lengthx + 1;
      i = i + 2;
    }
  }

  unicode = [];
  unicode.length = lengthx;

  pos = 0;
  for(i = 0; i < utf16.length; ){
    code = utf16[i].charCodeAt(0);

    if(code < surrogateLowerBound || code >= surrogateUpperBound){
      unicode[pos] = utf16[i].charCodeAt(0);
      i = i + 1;
      pos = pos + 1;
    }else{
      hs = utf16[i].charCodeAt(0);
      ls = utf16[i + 1].charCodeAt(0);

      unicode[pos] = (hs - highSurrogateBase)*highMultiplier + (ls - lowSurrogateBase) + surrogateBase;

      i = i + 2;
      pos = pos + 1;
    }
  }

  return unicode;
}
function UnicodeToUTF16(unicode){
  var utf16;
  var lengthx, code, i, pos, hs, ls;
  var highSurrogateBase, lowSurrogateBase, highMultiplier, surrogateBase;

  highSurrogateBase = 55296;
  lowSurrogateBase = 56320;
  highMultiplier = 1024;
  surrogateBase = 65536;

  lengthx = 0;
  for(i = 0; i < unicode.length; i = i + 1){
    if(unicode[i] < surrogateBase){
      lengthx = lengthx + 1;
    }else{
      lengthx = lengthx + 2;
    }
  }

  utf16 = [];
  utf16.length = lengthx;

  pos = 0;
  for(i = 0; i < unicode.length; i = i + 1){
    if(unicode[i] < surrogateBase){
      utf16[pos] = String.fromCharCode(unicode[i]);
      pos = pos + 1;
    }else{
      code = unicode[i] - surrogateBase;
      hs = Math.floor(code/highMultiplier) + highSurrogateBase;
      ls = code%highMultiplier + lowSurrogateBase;

      utf16[pos] = String.fromCharCode(hs);
      pos = pos + 1;
      utf16[pos] = String.fromCharCode(ls);
      pos = pos + 1;
    }
  }

  return utf16;
}
function UTF8ToUTF16(utf8){
  var unicode;
  var utf16;

  unicode = UTF8ToUnicode(utf8);
  utf16 = UnicodeToUTF16(unicode);

  delete(unicode);

  return utf16;
}
function UTF16ToUTF8(utf16){
  var unicode;
  var utf8;

  unicode = UTF16ToUnicode(utf16);
  utf8 = UnicodeToUTF8(unicode);

  delete(unicode);

  return utf8;
}
function IsValidUnicode(unicode){
  var lower, upper, i, code;
  var valid;

  lower = 0;
  upper = 1114112;

  valid = true;
  for(i = 0; i < unicode.length && valid; i = i + 1){
    code = unicode[i];

    if(code == Math.floor(code)){
      if(code >= lower && code < upper){
      }else{
        valid = false;
      }
    }else{
      valid = false;
    }
  }

  return valid;
}
function IsValidUtf16(utf16){
  var i, code;
  var valid;
  var surrogateLowerBound, surrogateUpperBound;

  surrogateLowerBound = 55296;
  surrogateUpperBound = 57344;

  valid = true;
  for(i = 0; i < utf16.length && valid; i = i + 1){
    code = utf16[i].charCodeAt(0);

    if(code == Math.floor(code)){
      if(code < surrogateLowerBound || code >= surrogateUpperBound){
      }else if(i + 1 < utf16.length){
        i = i + 1;
        code = utf16[i].charCodeAt(0);

        if(code < surrogateLowerBound || code >= surrogateUpperBound){
          valid = false;
        }
      }else{
        valid = false;
      }
    }else{
      valid = false;
    }
  }

  return valid;
}
function IsValidUtf8(utf8){
  var i, code1, code2, code3, code4;
  var valid;

  valid = true;
  for(i = 0; i < ByteArrayLength(utf8) && valid; i = i + 1){
    code1 = GetByte(utf8, i);

    if(code1 == Math.floor(code1)){
      if(code1 < 128){
      }else if(code1 < 128 + 64){
        valid = false;
      }else if(code1 < 128 + 64 + 32){
        if(i + 1 < ByteArrayLength(utf8)){
          i = i + 1;
          code2 = GetByte(utf8, i);

          if(code2 >= 128 && code2 < 128 + 64){
          }else{
            valid = false;
          }
        }else{
          valid = false;
        }
      }else if(code1 < 128 + 64 + 32 + 16){
        if(i + 2 < ByteArrayLength(utf8)){
          i = i + 1;
          code2 = GetByte(utf8, i);
          i = i + 1;
          code3 = GetByte(utf8, i);

          if(code2 >= 128 && code2 < 128 + 64 && code3 >= 128 && code3 < 128 + 64){
          }else{
            valid = false;
          }
        }else{
          valid = false;
        }
      }else if(i + 3 < ByteArrayLength(utf8)){
        i = i + 1;
        code2 = GetByte(utf8, i);
        i = i + 1;
        code3 = GetByte(utf8, i);
        i = i + 1;
        code4 = GetByte(utf8, i);

        if(code2 >= 128 && code2 < 128 + 64 && code3 >= 128 && code3 < 128 + 64 && code4 >= 128 && code4 < 128 + 64){
        }else{
          valid = false;
        }
      }else{
        valid = false;
      }
    }else{
      valid = false;
    }
  }

  return valid;
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !StringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}


module.exports = {
	PingInitialize: PingInitialize,
	PingFreeState: PingFreeState,
	PingIteration: PingIteration,
	Check: Check,
	Send: Send,
	Receive: Receive,
	Call: Call,
	ServerCheck: ServerCheck,
	ServerSend: ServerSend,
	ServerReceive: ServerReceive,
	StringToNumberArray: StringToNumberArray,
	NumberArrayToString: NumberArrayToString,
	NumberArraysEqual: NumberArraysEqual,
	BooleanArraysEqual: BooleanArraysEqual,
	StringsEqual: StringsEqual,
	FillNumberArray: FillNumberArray,
	FillString: FillString,
	FillBooleanArray: FillBooleanArray,
	FillNumberArrayRange: FillNumberArrayRange,
	FillBooleanArrayRange: FillBooleanArrayRange,
	FillStringRange: FillStringRange,
	CopyNumberArray: CopyNumberArray,
	CopyBooleanArray: CopyBooleanArray,
	CopyString: CopyString,
	CopyNumberArrayRange: CopyNumberArrayRange,
	CopyBooleanArrayRange: CopyBooleanArrayRange,
	CopyStringRange: CopyStringRange,
	IsLastElement: IsLastElement,
	CreateNumberArray: CreateNumberArray,
	CreateBooleanArray: CreateBooleanArray,
	CreateString: CreateString,
	SwapElementsOfNumberArray: SwapElementsOfNumberArray,
	SwapElementsOfStringArray: SwapElementsOfStringArray,
	ReverseNumberArray: ReverseNumberArray,
	ReadXbytes: ReadXbytes,
	Read4bytesBE: Read4bytesBE,
	Read2bytesBE: Read2bytesBE,
	ReadByte: ReadByte,
	Read4bytesLE: Read4bytesLE,
	WriteByte: WriteByte,
	Write2BytesLE: Write2BytesLE,
	Write4BytesLE: Write4BytesLE,
	Write2BytesBE: Write2BytesBE,
	Write4BytesBE: Write4BytesBE,
	WriteStringBytes: WriteStringBytes,
	BytesRound: BytesRound,
	ByteArrayToNumberArray: ByteArrayToNumberArray,
	NumberArrayToByteArray: NumberArrayToByteArray,
	ByteArraysEqual: ByteArraysEqual,
	CopyByteArray: CopyByteArray,
	ByteArrayLength: ByteArrayLength,
	CreateAndFillByteArray: CreateAndFillByteArray,
	CreateByteArray: CreateByteArray,
	SetByte: SetByte,
	GetByte: GetByte,
	AssertByteArraysEqual: AssertByteArraysEqual,
	FreeByteArray: FreeByteArray,
	CopyByteArrayRange: CopyByteArrayRange,
	BytesToTextBase16: BytesToTextBase16,
	TextToBytesBase16WithCheck: TextToBytesBase16WithCheck,
	TextToBytesBase16: TextToBytesBase16,
	FreeBase64ByteCombinations: FreeBase64ByteCombinations,
	GenerateBase16ByteCombinations: GenerateBase16ByteCombinations,
	UnicodeToUTF8: UnicodeToUTF8,
	UTF8ToUnicode: UTF8ToUnicode,
	UTF16ToUnicode: UTF16ToUnicode,
	UnicodeToUTF16: UnicodeToUTF16,
	UTF8ToUTF16: UTF8ToUTF16,
	UTF16ToUTF8: UTF16ToUTF8,
	IsValidUnicode: IsValidUnicode,
	IsValidUtf16: IsValidUtf16,
	IsValidUtf8: IsValidUtf8,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	test: test
};